package test3;

import COSC3P91.xml.XMLObject;
import COSC3P91.xml.XMLReader;
import java.io.Reader;

public class Employee implements XMLObject {
    
    private final String firstName, lastName;
    private final int age;
    private final int hourlyRate;
    
    private static XMLReader<Employee> reader = null;
    
    public static Employee read(Reader source) {
        if (reader==null) {
            reader = new XMLReader();
            reader.setXMLSchema("Employee.xsd");
            reader.setXMLNodeConverter(XMLNodeConverterEmplyee.getInstace());
        }
        return reader.readXML(source);
    }

    public Employee(String firstName, String lastName, int age, int hourlyRate) {
        this.firstName = firstName;
        this.lastName = lastName;
        this.age = age;
        this.hourlyRate = hourlyRate;
    }

    public int getHourlyRate() {
        return hourlyRate;
    }
    
    public int computeID() {
        return age + (int) firstName.charAt(0) + (int) lastName.charAt(0);
    }

    @Override
    public String toXMLString() {
        return "<Person firstName=\"" + firstName + "\" lastName=\"" + lastName + "\" age=\"" + age + "\" hourlyRate=\"" + hourlyRate +"\"/>";
    }
    
}
