package test3;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.io.IOException;
import java.io.StringReader;

public class EmployeeThread extends Thread {
    
    private final Queue<String> queue;

    public EmployeeThread(Queue<String> queue) {
        this.queue = queue;
    }
    
    @Override
    public void run() {
        try {
            BufferedReader personFile = new BufferedReader(new FileReader(new File("./XML/Employees.xml")));
            String line = personFile.readLine();
            while (line != null) {
                Employee employee = Employee.read(new StringReader(line));
                SalaryData salaryData = new SalaryData(employee.computeID(),employee.getHourlyRate());
                queue.push(salaryData.toXMLString());
                line = personFile.readLine();
            }
            personFile.close();
            queue.push(null);
        } catch (IOException ex) {
            ex.printStackTrace();
        }       
    }
    
}
