package test3;

import java.util.LinkedList;
import java.util.List;

public class Queue<E> {

    private final List<E> data;

    public Queue() {
        data = new LinkedList();
    }

    public synchronized void push(E element) {        
        data.add(element);
        notify();
    }

    public synchronized E pull()  {
        while (data.isEmpty()) {
            try { 
                wait(); 
            } catch (InterruptedException e) {}
        }
        return data.removeFirst();
    }
    
}
