package test3;

import COSC3P91.xml.XMLObject;
import COSC3P91.xml.XMLReader;
import java.io.Reader;

public class SalaryData implements XMLObject {
    
    private final int id;
    private final int hourlyRate;
    
    private static XMLReader<SalaryData> reader = null;
    
    public static SalaryData read(Reader source) {
        if (reader==null) {
            reader = new XMLReader();
            reader.setXMLSchema("SalaryData.xsd");
            reader.setXMLNodeConverter(XMLNodeConverterSalaryData.getInstace());
        }
        return reader.readXML(source);
    }

    public SalaryData(int id, int hourlyRate) {
        this.id = id;
        this.hourlyRate = hourlyRate;
    }
    
    public int getID() {
        return id;
    }
    
    public int getHourlyRate() {
        return hourlyRate;
    }
    
    public boolean check(int checkSum) {
        return computeCheckSum() == checkSum;
    }
    
    private int computeCheckSum() {
        return id % 16;
    }

    @Override
    public String toXMLString() {
        return "<SalaryData id=\"" + id + "\" checkSum=\"" + computeCheckSum() + "\" hourlyRate=\"" + hourlyRate + "\"/>";
    }
    
}
