package test3;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.io.IOException;
import java.io.StringReader;

public class WorkDataThread extends Thread {
    
    private final Queue<String> queue;
    private final int bonusHours;

    public WorkDataThread(Queue<String> queue, int bonusHours) {
        this.queue = queue;
        this.bonusHours = bonusHours;
    }
    
    @Override
    public void run() {
        try {
            BufferedReader salaryFile = new BufferedReader(new FileReader(new File("./XML/WorkData.xml")));
            String line = salaryFile.readLine();
            while (line != null) {
                WorkData data = WorkData.read(new StringReader(line));
                data.addHours(bonusHours);
                queue.push(data.toXMLString());
                line = salaryFile.readLine();
            }
            salaryFile.close();
            queue.push(null);
        } catch (IOException ex) {
            ex.printStackTrace();
        } 
    }
    
}
